[![CI Status](https://github.com/tradingstrategy-ai/client/actions/workflows/python-app.yml/badge.svg)](https://github.com/tradingstrategy-ai/client/actions/workflows/python-app.yml)

[![pip installation works](https://github.com/tradingstrategy-ai/client/actions/workflows/pip-install.yml/badge.svg)](https://github.com/tradingstrategy-ai/client/actions/workflows/pip-install.yml)

# Trading Strategy protocol client

Trading Strategy client is a Python library for on-chain algorithmic trading and trading bots. 

# Use cases

* Analysing of cryptocurrency investment opportunities

* Creating trading algorithms and bots that operate on on-chain data

# Features

* Getting trading data from on-chain decentralised exchanges like Uniswap and PancakeSwap

* Integration with [Jupyter Notebook](https://jupyter.org/) for easy manipulation of data 

* Use Python quant toolkits like [Backtrader](https://tradingstrategy.ai/docs/glossary.html#term-Backtrader) to create, analyse and backtest DEX trading algorithms 

* (*soon*) Decentralised execution of trading algorithms through smart contracts

# Example and getting started 

See [the Getting Started notebook](https://tradingstrategy.ai/docs/programming/examples/getting-started.html) and the rest of the [Trading Strategy documentation](https://tradingstrategy.ai/docs/).

## Prerequisites

Python 3.7+

## Adding the package

**Note**: Unless you are an experienced Python developer, [the suggested usage of Trading Algorithm framework is using Google Colab hosted environments](https://tradingstrategy.ai/docs/programming/examples/getting-started.html).

You can install this package with `pip` or `poetry`

```shell
pip install tradindstrategy 
```

```shell
poetry add tradindstrategy
```

# License

GNU AGPL 3.0. 
